'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var convert = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(_ref2) {
    var source = _ref2.source;
    var target = _ref2.target;
    var _ref2$rows = _ref2.rows;
    var rows = _ref2$rows === undefined ? 3 : _ref2$rows;
    var _ref2$columns = _ref2.columns;
    var columns = _ref2$columns === undefined ? 3 : _ref2$columns;
    var _ref2$margin = _ref2.margin;
    var margin = _ref2$margin === undefined ? '25%' : _ref2$margin;
    var _ref2$cwd = _ref2.cwd;
    var cwd = _ref2$cwd === undefined ? process.cwd() : _ref2$cwd;

    var input, _ref3, width, height, tiles;

    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            (0, _invariant2.default)(typeof source === 'string', '"source" need to be a path');
            (0, _invariant2.default)(typeof rows === 'number', '"rows" need to be a number');
            (0, _invariant2.default)(typeof columns === 'number', '"columns" need to be a number');
            (0, _invariant2.default)(target.indexOf('{row}') >= 0, '"{row}" is required in target');
            (0, _invariant2.default)(target.indexOf('{column}') >= 0, '"{column}" is required in target');

            source = (0, _path.resolve)(cwd, source);

            (0, _invariant2.default)((0, _fs.existsSync)(source), 'source needs to exist');

            input = (0, _fs.createReadStream)(source);
            _context.next = 10;
            return (0, _probeImageSize2.default)(input);

          case 10:
            _ref3 = _context.sent;
            width = _ref3.width;
            height = _ref3.height;
            tiles = (0, _utils.calculateTiles)({
              width: width, height: height, columns: columns, rows: rows, margin: margin
            });
            _context.next = 16;
            return _promise2.default.all(tiles.map(function (tile) {
              var tilePath = (0, _path.resolve)(cwd, (0, _interpolate2.default)(target, { column: tile.column, row: tile.row }));

              _mkdirp2.default.sync((0, _path.dirname)(tilePath));

              var params = {
                src: source,
                dst: tilePath,
                cropwidth: tile.width,
                cropheight: tile.height,
                x: tile.left,
                y: tile.top,
                gravity: 'NorthWest'
              };

              return _easyimage2.default.crop(params);
            }));

          case 16:
            return _context.abrupt('return');

          case 17:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function convert(_x) {
    return _ref.apply(this, arguments);
  };
}();

var _fs = require('fs');

var _path = require('path');

var _easyimage = require('easyimage');

var _easyimage2 = _interopRequireDefault(_easyimage);

var _interpolate = require('interpolate');

var _interpolate2 = _interopRequireDefault(_interpolate);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _mkdirp = require('mkdirp');

var _mkdirp2 = _interopRequireDefault(_mkdirp);

var _probeImageSize = require('probe-image-size');

var _probeImageSize2 = _interopRequireDefault(_probeImageSize);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = convert;